require 'thor'

module Puddle
  module Cli
    class BaseCli < Thor
      class_option :token
      class_option :format, type: :string, default: 'cli'

      map %w[--version -v] => :__display_version

      def self.exit_on_failure?
        true
      end

      desc "--version", "prints the current version"
      def __display_version
        $stdout.puts Puddle::VERSION
      end

      no_commands do
        def print_results(results)
          if results[:error]
            str = if results[:error].respond_to?(:message)
                    results[:error].message
                  else
                    results[:error].to_s
                  end
            raise Thor::Error, str
          end

          $stdout.puts results[:content]
        end
      end
    end
  end
end
