module Puddle
  module Resources
    class ShowAccount
      attr_reader :adapter, :options

      def initialize(http_adapter, options = {})
        @adapter = http_adapter
        @options = options
      end

      def execute
        results = adapter.api(:get, 'account', options)
        return results if options['format'] == 'json'

        cli_format(results)
      end

      def cli_format(results)
        results = results['account']

        data = ''
        data << sprintf("droplet limit:  %-s\n", results['droplet_limit'])
        data << sprintf("email:          %-s\n", results['email'])
        data << sprintf("uuid:           %-s\n", results['uuid'])
        data << sprintf("email verified: %-s\n", results['email_verified'])
        data
      end
    end
  end
end
